import { createRoute, OpenAPIHono, z } from "@hono/zod-openapi";
import type { User } from "../../../../types/users.js";
import { verify } from "hono/jwt";
import { updateSetting } from "../../controller/settings/updateSetting.js";
import { apiHit } from "../../../../globalUtils/apiHits.js";

const app = new OpenAPIHono();

const UpdateSetting = z.object({
    name: z.string().openapi({ example: "server" }),
    value: z.string().openapi({ example: "localhost" }),
});

app.openapi(
    createRoute({
        tags: ["server:settings"],
        summary: "Updates A setting",
        method: "patch",
        path: "/settings",
        request: {
            body: {
                content: {
                    "application/json": { schema: UpdateSetting },
                },
            },
        },
        responses: {
            200: {
                content: {
                    "application/json": {
                        schema: z.object({
                            success: z.boolean().openapi({ example: true }),
                            message: z.string().openapi({ example: "Starter" }),
                        }),
                    },
                },
                description: "Response message",
            },
            400: {
                content: {
                    "application/json": {
                        schema: z.object({
                            message: z
                                .string()
                                .optional()
                                .openapi({ example: "Internal Server error" }),
                        }),
                    },
                },
                description: "Internal Server Error",
            },
            401: {
                content: {
                    "application/json": {
                        schema: z.object({
                            message: z
                                .string()
                                .optional()
                                .openapi({ example: "Unauthenticated" }),
                        }),
                    },
                },
                description: "Unauthorized",
            },
            500: {
                content: {
                    "application/json": {
                        schema: z.object({
                            message: z
                                .string()
                                .optional()
                                .openapi({ example: "Internal Server error" }),
                        }),
                    },
                },
                description: "Internal Server Error",
            },
        },
    }),
    async (c) => {
        // make sure we have a vaid user being accessed thats really logged in
        const authHeader = c.req.header("Authorization");

        if (authHeader?.includes("Basic")) {
            return c.json(
                {
                    message:
                        "You are a Basic user! Please login to get a token",
                },
                401
            );
        }

        if (!authHeader) {
            return c.json({ message: "Unauthorized" }, 401);
        }

        const token = authHeader?.split("Bearer ")[1] || "";
        let user: User;

        try {
            const payload = await verify(token, process.env.JWT_SECRET!);
            user = payload.user as User;
        } catch (error) {
            return c.json({ message: "Unauthorized" }, 401);
        }

        // now pass all the data over to update the user info
        try {
            const data = await c?.req.json();
            apiHit(c, { endpoint: `/updatesettings`, lastBody: data });
            await updateSetting(data, user.user_id ?? "");
            return c.json(
                {
                    success: true,
                    message: "The Setting was just updated",
                    data,
                },
                200
            );
        } catch (error) {
            return c.json(
                { message: "There was an error updating the settings.", error },
                400
            );
        }
    }
);
export default app;
